#!/usr/bin/env python

import stph

taskattribs=['name', 'icon_name', 'wm_class', 'instance', 'focused',
             'iconified', 'frame_pos', 'frame_dims', 'win_pos', 'win_dims',
             'desktop', 'area', 'layer', 'xwin', 'xframe', 'icon_pixmap',
             'icon_mask', 'icon_window', 'kwm_icon_pixmap', 'kwm_icon_mask',
             'sticky', 'minimized', 'maximized_vert', 'maximized_horiz',
             'hidden', 'shaded', 'hid_workspace', 'hid_transient',
             'fixed_position', 'arrange_ignore', 'skip_focus',
             'skip_winlist', 'skip_taskbar', 'group_transient',
             'focus_on_click', 'do_not_cover']
viewattribs=['area', 'area_count', 'desktop', 'desktop_count']

def callback(struct, string="", attrlist=[]):
    print "---------------------------------------------------"
    print string
    print
    for attr in attrlist:
        print "%s: %s" % (attr, repr(getattr(struct, attr)))

def connect(cbstr, callbacktype, attrlist):
    def realcallback(struct, cbstr=cbstr, cbtype=callbacktype, at=attrlist):
        callback(struct, "%s callback: %s" % (cbtype, cbstr), at)
    stph.connect(getattr(stph, cbstr), realcallback)

for cb in ['ADD_TASK_CB', 'REMOVE_TASK_CB', 'TASK_NAME_CB',
           'TASK_ICON_NAME_CB', 'TASK_CLASS_CB', 'TASK_STATE_CB',
           'TASK_HINTS_CB', 'TASK_FOCUS_CB', 'TASK_ICONIFY_CB',
           'TASK_FRAME_CB', 'TASK_FRAME_DIMS_CB', 'TASK_FRAME_POS_CB',
           'TASK_WIN_DIMS_CB', 'TASK_WIN_POS_CB', 'TASK_LAYER_CB',
           'TASK_DESKTOP_CB', 'TASK_AREA_CB', 'TASK_ICON_PIXMAP_CB',
           'TASK_ICON_WINDOW_CB', 'TASK_KWM_ICON_CB']:
    connect(cb, "Task-related", taskattribs)

for cb in ['AREA_CB', 'AREA_COUNT_CB', 'WORKSPACE_CB',
           'WORKSPACE_COUNT_CB']:
    connect(cb, "Viewport/workspace-related", viewattribs)

t=stph.initialise()
if t:
    if t==2:
        print "Gnome compliant window manager not found"
    else: print "Unknown error initializing"
else:
    while 1:
        stph.mainiteration()
