#! /usr/bin/env python

from gtk import *
import stph
import time
import os
import re
import string
import copy
import cPickle

#globals:
fixup_names_mutex = 0

debug = 1

clock_formats = {'Y': ('%d','year', '4-digit year'),
                 'y': ('%02d', 'year%100', '2-digit year'),
                 'M': ('%s', 'self.months[month]', 'month as letters'),
                 'm': ('%d', 'month', 'month as digits'),
                 'd': ('%d', 'day', 'day of month'),
                 'H': ('%d', 'hh', 'hour (military style)'),
                 'h': ('%d', 'hh%12 or 12', 'hour (civilian style)'),
                 'i': ('%02d', 'mm', 'minute'),
                 's': ('%02d', 'ss', 'second'),
                 'W': ('%s', 'self.weekdays[wkday]', 'day of week'),
                 'n': ('%s', 'hh < 12 and "am" or "pm"', 'am/pm indicator')}

icon_size = 16
# stolen from the gnome tasklist:
default_icon = ["16 16 10 1",
                "       c None",
                ".      c #000000",
                "+      c #D89C90",
                "@      c #D06458",
                "#      c #843424",
                "$      c #505448",
                "%      c #E0E4E0",
                "&      c #9CACA4",
                "*      c #D0D4C4",
                "=      c #909894",
                "                ",
                " .............. ",
                " .@@@@@@@@@@@@. ",
                " .$$$$$$$$$$$$. ",
                " .%&%&%&%&%&%&. ",
                " .&*&*&*&*&*&=. ",
                " .%&*&*&*&*&*&. ",
                " .&*&*&*&*&*&=. ",
                " .%&*&*&*&*&*&. ",
                " .&*&*&*&*&*&=. ",
                " .%&*&*&*&*&*&. ",
                " .&*&*&*&*&*&=. ",
                " .%&*&*&*&*&*&. ",
                " .&=&=&=&=&=&=. ",
                " .............. ",
                "                "]

class MatchEdit(GtkWindow):
    #FIXME: this whole class is a bloody mess
    def __init__(self, matchconfig, matchindex):
        GtkWindow.__init__(self, WINDOW_DIALOG)
        self.set_title("Timbar: Edit Matcher")
        self.mc = matchconfig
        self.mi = matchindex
        self.set_transient_for(self.mc.conf)
        self.connect("delete_event", self.cancel_cb)
        
        self.mainbox = GtkVBox()
        self.add(self.mainbox)
        self.mainbox.show()
        self.widgets = {}

        #FIXME: All this packing is ridiculous; better done iteratively based on a spec,
        #         or maybe with glade...
        
        # Matching Frame:
        mframe = GtkFrame("Match Against")
        mframe.show()
        self.mainbox.pack_start(mframe, FALSE,FALSE,5)
        mbox = GtkVBox()
        mbox.show()
        mframe.add(mbox)

        #class:
        box = GtkHBox()
        box.show()
        mbox.pack_start(box)
        a = GtkCheckButton("Class:")
        a.show()
        box.pack_start(a, FALSE,FALSE)
        e = GtkEntry()
        e.show()
        box.pack_start(e, FALSE,FALSE)
        self.widgets['class'] = [a, e]

        #instance:
        box = GtkHBox()
        box.show()
        mbox.pack_start(box)
        a = GtkCheckButton("Instance:")
        a.show()
        box.pack_start(a, FALSE,FALSE)
        e = GtkEntry()
        e.show()
        box.pack_start(e, FALSE,FALSE)
        self.widgets['instance'] = [a, e]

        #name:
        box = GtkHBox()
        box.show()
        mbox.pack_start(box)
        a = GtkCheckButton("Name:")
        a.show()
        box.pack_start(a, FALSE,FALSE)
        e = GtkEntry()
        e.show()
        box.pack_start(e, FALSE,FALSE)
        self.widgets['name'] = [a, e]

        # Properties Frame:
        sframe = GtkFrame("Properties")
        sframe.show()
        self.mainbox.pack_start(sframe, FALSE,FALSE,5)
        sbox = GtkVBox()
        sbox.show()
        sframe.add(sbox)
        
        #icon:
        box = GtkHBox()
        box.show()
        sbox.pack_start(box)
        a = GtkCheckButton("icon:")
        a.show()
        box.pack_start(a, FALSE,FALSE)
        e = GtkEntry()
        e.show()
        box.pack_start(e, FALSE,FALSE)
        b = GtkButton("Browse...")
        b.connect("clicked", self.browse_for_icon)
        b.show()
        box.pack_start(b, FALSE,FALSE)
        self.widgets['icon'] = [a, e]

        #substitute-in-name:
        box = GtkHBox()
        box.show()
        sbox.pack_start(box)
        a = GtkCheckButton("Replace:")
        a.show()
        box.pack_start(a, FALSE,FALSE)
        e = GtkEntry()
        e.show()
        box.pack_start(e, FALSE,FALSE)
        l = GtkLabel(" in name with: ")
        l.show()
        box.pack_start(l, FALSE,FALSE)
        f = GtkEntry()
        f.show()
        box.pack_start(f, FALSE,FALSE)
        self.widgets['replace-in-name'] = [a, e, f]

        # OK and Cancel buttons:
        bbox = GtkHButtonBox()
        bbox.show()
        okbut = GtkButton("OK")
        okbut.connect("clicked", self.ok_cb)
        bbox.pack_start(okbut, FALSE,FALSE,0)
        okbut.show()
        canbut = GtkButton("Cancel")
        canbut.connect("clicked", self.cancel_cb)
        bbox.pack_start(canbut)
        canbut.show()
        
        self.mainbox.pack_start(bbox, FALSE,FALSE,10)
        self.update_display()

    def ok_cb(self, but):
        npm = self.mc.conf.new_params['matchers']
        mi = self.mi
        if mi < 0:
            mi = len(npm)
            npm.append([{},{}])

        #FIXME: produce a more general solution
        for st in ['class', 'instance', 'name']:
            if self.widgets[st][0].get_active():
                npm[mi][0][st] = self.widgets[st][1].get_text()
            elif npm[mi][0].has_key(st):
                del npm[mi][0][st]
            
        for st in ['icon']:
            if self.widgets[st][0].get_active():
                npm[mi][1][st] = self.widgets[st][1].get_text()
            elif npm[mi][1].has_key(st):
                del npm[mi][1][st]

        for st in ['replace-in-name']:
            if self.widgets[st][0].get_active():
                npm[mi][1][st] = [self.widgets[st][1].get_text(), self.widgets[st][2].get_text()]
            elif npm[mi][1].has_key(st):
                del npm[mi][1][st]

        self.mc.update_display()
        self.mc.set_sensitive(TRUE)
        self.hide()
        
    def cancel_cb(self, *args):
        self.hide()
        if hasattr(self, 'filesel'):
            self.filesel.hide()
            self.filesel.destroy()
            del self.filesel

        self.set_sensitive(TRUE)
        self.mc.set_sensitive(TRUE)
        return TRUE #don't destroy window

    def browse_for_icon(self, but):
        #FIXME: this would be better off in its own class
        self.set_sensitive(FALSE)
        entry = self.widgets['icon'][1]
        oldpath = entry.get_text()
        self.filesel = GtkFileSelection()
        self.filesel.set_title("Timbar: Choose Icon")
        self.filesel.set_transient_for(self)
        
        if os.path.exists(oldpath):
            self.filesel.complete(os.path.dirname(oldpath))
        elif os.path.exists('/usr/share/icons'):
            self.filesel.complete('/usr/share/icons')
        else:
            self.filesel.complete(os.path.expanduser('~'))
        self.filesel.show()

        def cancel_cb(but=None, self=self):
            self.filesel.hide()
            self.filesel.destroy()
            del self.filesel
            self.set_sensitive(TRUE)

        def delete_cb(one, two, func=cancel_cb):
            func()

        def ok_cb(but, self=self, entry=entry):
            entry.set_text(self.filesel.get_filename())
            self.filesel.hide()
            self.filesel.destroy()
            del self.filesel
            self.set_sensitive(TRUE)
            
        self.filesel.ok_button.connect("clicked", ok_cb)
        self.filesel.cancel_button.connect("clicked", cancel_cb)
        self.filesel.connect("delete_event", delete_cb)
        

    def update_display(self):
        npm = self.mc.conf.new_params['matchers']
        mi = self.mi
        # FIXME: produce a more general solution

        for st in ['class', 'instance', 'name']:
            self.widgets[st][0].set_active(FALSE)
            self.widgets[st][1].set_text("")
        for st in ['icon']:
            self.widgets[st][0].set_active(FALSE)
            self.widgets[st][1].set_text("")
        for st in ['replace-in-name']:
            self.widgets[st][0].set_active(FALSE)
            self.widgets[st][1].set_text("")
            self.widgets[st][2].set_text("")
            
        if mi >= 0:
            for st in ['class', 'instance', 'name']:
                if npm[mi][0].has_key(st) and npm[mi][0][st]:
                    self.widgets[st][0].set_active(TRUE)
                    self.widgets[st][1].set_text(npm[mi][0][st])
            for st in ['icon']:
                if npm[mi][1].has_key(st) and npm[mi][1][st]:
                    self.widgets[st][0].set_active(TRUE)
                    self.widgets[st][1].set_text(npm[mi][1][st])
            for st in ['replace-in-name']:
                if npm[mi][1].has_key(st) and npm[mi][1][st]:
                    self.widgets[st][0].set_active(TRUE)
                    self.widgets[st][1].set_text(npm[mi][1][st][0])
                    self.widgets[st][2].set_text(npm[mi][1][st][1])
                

class MatchConfig(GtkFrame):
    def __init__(self, configurator):
        GtkFrame.__init__(self, "Task Properties")
        self.conf = configurator
        mainbox = GtkVBox()
        self.add(mainbox)

        self.clist = GtkCList(2, ["Match Against", "Properties"])
        self.update_display()
        swin = GtkScrolledWindow()
        swin.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        swin.show()
        self.clist.show()
        self.clist.set_column_auto_resize(0,TRUE)
        self.clist.set_column_auto_resize(1,TRUE)
        swin.add(self.clist)
        mainbox.pack_start(swin)
        
        bbox = GtkHButtonBox()
        mainbox.pack_start(bbox, FALSE,FALSE,0)
        bbox.show()

        addbut = GtkButton("Add")
        addbut.connect("clicked", self.add_cb)
        bbox.pack_start(addbut)
        addbut.show()
        editbut = GtkButton("Edit")
        editbut.connect("clicked", self.edit_cb)
        bbox.pack_start(editbut)
        editbut.show()
        delbut = GtkButton("Delete")
        delbut.connect("clicked", self.delete_cb)
        bbox.pack_start(delbut)
        delbut.show()
        
        mainbox.show()
        self.show()
        
    def add_cb(self, but):
        if hasattr(self, 'matchedit'):
            self.matchedit.mi = -1
            self.matchedit.update_display()
            self.matchedit.show()
            self.set_sensitive(FALSE)
        else:
            self.matchedit = MatchEdit(self, -1)
            self.matchedit.show()
            self.set_sensitive(FALSE)
        
    def edit_cb(self, but):
        if self.clist.selection:
            if hasattr(self, 'matchedit'):
                self.matchedit.mi = self.clist.focus_row
                self.matchedit.update_display()
                self.matchedit.show()
                self.set_sensitive(FALSE)
            else:
                self.matchedit = MatchEdit(self, self.clist.focus_row)
                self.matchedit.show()
                self.set_sensitive(FALSE)
            
    def delete_cb(self,but):
        if self.clist.selection:
            del self.conf.new_params['matchers'][self.clist.focus_row]
            self.update_display()

    def update_display(self):
        self.clist.clear()
        self.clist.freeze()
        for lst in self.conf.new_params['matchers']:
            line = ["", ""]
            for key in lst[0].keys():
                line[0] = line[0] + key + "=" + lst[0][key] + " "
            for key in lst[1].keys():
                line[1] = line[1] + key
                if lst[1][key]:
                    line[1] = line[1] + "=" + str(lst[1][key])
                line[1] = line[1] + " "
            self.clist.append(line)
        self.clist.select_row(0,0)
        self.clist.thaw()

class ClockConfig(GtkFrame):
    def __init__(self, configurator):
        GtkFrame.__init__(self, "Clock Format")
        self.conf = configurator
        mainbox = GtkVBox()
        self.add(mainbox)

        self.entry = GtkEntry()
        self.update_display()
        self.entry.connect("changed", self.update_params)
        self.entry.show()
        mainbox.pack_start(self.entry)

        bbox = GtkVButtonBox()
        bbox.show()
        mainbox.pack_start(bbox)

        global clock_formats

        for key in clock_formats.keys():
            b = GtkButton(clock_formats[key][2] + " (%" + key + ")")
            b.show()
            b.connect("clicked", self.insert_text, key)
            bbox.pack_start(b)

        self.entry.grab_focus()
        mainbox.show()
        self.show()

    def insert_text(self, but, format):
        pos = self.entry.get_position()
        text = self.entry.get_text()
        self.entry.set_text(text[:pos] + "%" + format + text[pos:])
        self.entry.set_position(pos+2)
        self.entry.grab_focus()
        
    def update_params(self, entry):
        self.conf.new_params['clock-format'] = entry.get_text()

    def update_display(self):
        self.entry.set_text(self.conf.new_params['clock-format'])
        

class Configurator(GtkWindow):
    def __init__(self, app):
        GtkWindow.__init__(self, WINDOW_DIALOG)
        self.app = app
        #self.set_transient_for(self.app)
        self.backup_params = copy.deepcopy(self.app.params)
        self.new_params = copy.deepcopy(self.app.params)
        self.set_title("Timbar: Configurator")
        self.connect("delete_event", self.cancel_cb)
        self.set_default_size(640,480)
        self.notebook = GtkNotebook()
        self.mainbox = GtkVBox()
        self.mainbox.pack_start(self.notebook)
        self.mainbox.show()
        self.add(self.mainbox)
        self.bbox = GtkHButtonBox()
        self.mainbox.pack_start(self.bbox, FALSE,FALSE,10)
        self.bbox.show()

        trybut = GtkButton("Try")
        trybut.connect("clicked", self.try_cb)
        self.bbox.pack_start(trybut)
        trybut.show()
        revbut = GtkButton("Revert")
        revbut.connect("clicked", self.revert_cb)
        self.bbox.pack_start(revbut)
        revbut.show()
        okbut = GtkButton("OK")
        okbut.connect("clicked", self.ok_cb)
        self.bbox.pack_start(okbut)
        okbut.show()
        canbut = GtkButton("Cancel")
        canbut.connect("clicked", self.cancel_cb)
        self.bbox.pack_start(canbut)
        canbut.show()

        self.matchconfig = MatchConfig(self)
        self.notebook.append_page(self.matchconfig, GtkLabel("Task Properties"))
        self.clockconfig = ClockConfig(self)
        self.notebook.append_page(self.clockconfig, GtkLabel("Clock Format"))
        ### FIXME: more pages to add yet...
        self.notebook.show()
        #self.show()

    def try_cb(self, *args):
        self.app.params = copy.deepcopy(self.new_params)
        for b in self.app.buttons.values():
            b.update_icon()
            b.update_dname()

        self.app.clock.update_exec_string()
        self.app.clock.update()
        self.app.fixup_names()

    def revert_cb(self, *args):
        self.new_params = copy.deepcopy(self.backup_params)
        self.matchconfig.update_display()
        self.clockconfig.update_display()
        self.try_cb()

    def ok_cb(self, *args):
        if hasattr(self.matchconfig, 'matchedit'):
            self.matchconfig.matchedit.cancel_cb()
        self.try_cb()
        f = open(os.path.expanduser("~/.timbarrc"), 'w')
        cPickle.dump(self.app.params, f)
        f.close()
        self.backup_params = copy.deepcopy(self.app.params)
        self.hide()
        
        
    def cancel_cb(self, *args):
        if hasattr(self.matchconfig, 'matchedit'):
            self.matchconfig.matchedit.cancel_cb()
        self.revert_cb()
        self.hide()
        return TRUE #don't destroy window
        

    
class TaskButton(GtkToggleButton):
    def __init__(self, task, expander):
        GtkToggleButton.__init__(self)
        self.task = task
        self.expander = expander
        self.mainbox = GtkHBox()
        self.mainbox.show()
        self.add(self.mainbox)
        self.icon = None
        self.update_icon()
        self.label = GtkLabel()
        self.label.show()
        self.mainbox.pack_start(self.label, FALSE,FALSE,2)
        self.connect("toggled", self.do_focus)
        self.update_dname() #displayed name

    def do_focus(self, but):
        if but.get_active():
            if not self.task.focused:
                self.task.focus()
                self.task.raise_window()
        elif self.task.focused:
            but.set_active(TRUE)

    def best_match(self, prop):
        matchers = self.expander.app.params['matchers']
        best = 0
        ret = None
        for m in matchers:
            if m[1].has_key(prop):
                score = 0
                if m[0].has_key('class') and (re.match(m[0]['class'], self.task.wm_class) != None):
                    score = score + 1
                if m[0].has_key('instance') and (re.match(m[0]['instance'],
                                                          self.task.instance) != None):
                    score = score + 2
                if m[0].has_key('name') and (re.match(m[0]['name'], self.task.name) != None):
                    score = score + 4
                if score > best:
                    best = score
                    ret = m
        return ret

    def update_dname(self):
        m = self.best_match('replace-in-name')
        if m:
            self.dname = string.join(string.split(self.task.name, m[1]['replace-in-name'][0]),
                                     m[1]['replace-in-name'][1])
        else:
            self.dname = self.task.name
            

    def update_icon(self):
        if self.icon:
            self.mainbox.remove(self.icon)
            self.icon.destroy()

        m = self.best_match('icon')
        if m and os.path.exists(m[1]['icon']) and m[1]['icon'][-4:] == '.xpm':
            s = m[1]['icon']
            self.icon = GtkPixmap(self.expander.app, s, None)
        elif self.task.icon_pixmap or self.task.kwm_icon_pixmap or self.task.icon_window:
            #FIXME: hardcoded icon size at 16x16 should be configurable...
            if self.task.icon_pixmap:
                xpm_d = stph.xpm_data_from_drawable(self.task.icon_pixmap,
                                                    self.task.icon_mask, icon_size, icon_size)
            elif self.task.kwm_icon_pixmap:
                xpm_d = stph.xpm_data_from_drawable(self.task.kwm_icon_pixmap,
                                                    self.task.kwm_icon_mask, icon_size, icon_size)
            else:
                xpm_d = stph.xpm_data_from_drawable(self.task.icon_window,
                                                    0, icon_size, icon_size)
            p = create_pixmap_from_xpm_d(self.mainbox, None, xpm_d)
            self.icon = GtkPixmap(p[0], p[1])
        else:
            p = create_pixmap_from_xpm_d(self.mainbox, None, default_icon)
            self.icon = GtkPixmap(p[0], p[1])
        self.icon.show()
        self.mainbox.pack_start(self.icon, FALSE,FALSE,2)
        self.mainbox.reorder_child(self.icon, 0)
        self.expander.app.fixup_names()
        #FIXME: this shouldn't call fixup_names() unless icon is changed

class Expander:
    def __init__(self, app):
        self.app = app
        self.outerbox = GtkHBox()
        self.but = GtkToggleButton()
        self.but.set_usize(15,-1) #FIXME: make configurable
        self.but.set_active(TRUE)
        self.but.show()
        self.label = GtkLabel("")
        self.but.add(self.label)
        self.label.show()
        self.innerbox = GtkHBox()
        self.innerbox.show()
        self.expanded = 1
        self.but.connect("toggled", self.toggle_cb)
        self.outerbox.pack_start(self.but, FALSE,FALSE,0)
        self.outerbox.pack_start(self.innerbox, FALSE,FALSE,0)
        self.outerbox.show()
        
    def toggle_cb(self, but):
        if but.get_active():
            self.expand()
        else:
            self.contract()
            
    def expand(self):
        if not self.expanded:
            self.innerbox.show()
            self.but.set_active(TRUE)
            self.expanded = 1
            if self.innerbox.children():
                self.app.fixup_names()

    def contract(self):
        if self.expanded:
            self.innerbox.hide()
            self.but.set_active(FALSE)
            self.expanded = 0
            if self.innerbox.children():
                self.app.fixup_names()


class ClockButton(GtkToggleButton):
    def __init__(self, app):
        GtkToggleButton.__init__(self)
        self.app = app
        self.connect("toggled", self.blah)
        self.label = GtkLabel()
        self.add(self.label)
        self.label.show()
        self.update_exec_string()
        self.update()
        self.show()
        timeout_add(1000, self.update)

    weekdays = ['Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat', 'Sun']
    months = ['', 'Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']

    def update(self):
        year, month, day, hh, mm, ss, wkday, y, z = time.localtime(time.time())
        #s = "%s %d %s, %d : %02d : %02d" % (self.weekdays[wkday], day, self.months[month], hh%12 or 12, mm, ss)
        exec self.exec_string
        self.label.set_text(s)
        return TRUE

    def blah(self, but):
        if but.get_active():
            if hasattr(self.app, 'configurator'):
                self.app.configurator.show()
            else:
                self.app.configurator = Configurator(self.app)
                self.app.configurator.show()
            but.set_active(FALSE)

    def update_exec_string(self):
        global clock_formats
        fstr = ""
        vstr = ""
        lst = string.split(self.app.params['clock-format'], "%")
        fstr = fstr + lst[0]
        for item in lst[1:]:
            ch = item[:1]
            if clock_formats.has_key(ch):
                fstr = fstr + clock_formats[ch][0] + item[1:]
                vstr = vstr + clock_formats[ch][1] + ","
        fstr = '"' + fstr + '"'
        vstr = '(' + vstr + ')'
        self.exec_string = "s = " + fstr + " % " + vstr
        
        
        
class Application(GtkWindow):
    def __init__(self):
        GtkWindow.__init__(self, WINDOW_TOPLEVEL)
        self.set_title("Timbar")
        self.set_usize(screen_width(), -1)
        self.connect("delete_event", mainquit)
        self.mainbox = GtkHBox()
        self.add(self.mainbox)
        self.mainbox.show()
        self.buttons = {}
        self.wspaces = []

        if os.path.exists(os.path.expanduser("~/.timbarrc")):
            f = open(os.path.expanduser("~/.timbarrc"), 'r')
            self.params = cPickle.load(f)
            f.close()
        else:
            self.params = {'matchers': [],
                           'clock-format': "%W %d/%m, %h : %i : %s %n"}

        self.clock = ClockButton(self)
        self.mainbox.pack_start(self.clock, FALSE,FALSE,0)
        
        stph.connect(stph.ADD_TASK_CB, self.add_task_cb) #callback id; function
        stph.connect(stph.REMOVE_TASK_CB, self.remove_task_cb)
        stph.connect(stph.TASK_FOCUS_CB, self.task_focus_cb)
        stph.connect(stph.TASK_NAME_CB, self.task_name_cb)
        stph.connect(stph.TASK_DESKTOP_CB, self.task_desktop_cb)
        stph.connect(stph.WORKSPACE_COUNT_CB, self.workspace_count_cb)
        stph.connect(stph.WORKSPACE_CB, self.workspace_cb)
        stph.connect(stph.TASK_HINTS_CB, self.task_hints_cb)
        stph.connect(stph.TASK_ICON_PIXMAP_CB, self.task_icon_cb)
        stph.connect(stph.TASK_ICON_WINDOW_CB, self.task_icon_cb)
        stph.connect(stph.TASK_KWM_ICON_CB, self.task_icon_cb)

        global fixup_names_mutex
        fixup_names_mutex = 1
        if stph.initialise(): #initialise stph; check for nonzero return (error)
            raise "stph init error" #really you should do a bit more to handle an error here ;)
        fixup_names_mutex = 0
        self.fixup_names()

        self.timtag = timeout_add(30, self.update) #ensure stph keeps updating, say every 30ms
        
        self.show()

    def update(self):
        stph.mainiteration() #this is very low overhead; it just returns if no X events pending
        return TRUE #ensure timeout is called again

    def task_name_cb(self, task):
        if task.skip_taskbar:
            return
        global fixup_names_mutex
        fixup_names_mutex = 1
        for b in self.buttons.values():
            b.update_icon()
            b.update_dname()
        fixup_names_mutex = 0
        self.fixup_names()

    def task_icon_cb(self, task):
        if task.skip_taskbar:
            return
        self.buttons[task.xwin].update_icon()

    def workspace_cb(self, root):
        for i in range(len(self.wspaces)):
            if root.workspace == i or len(self.wspaces[i].innerbox.children()) == 0:
                self.wspaces[i].expand()
                
            
    def task_desktop_cb(self, task):
        try:
            b = self.buttons[task.xwin]
        except KeyError:
            return
        b.expander.innerbox.remove(b)
        new_ws = self.wspaces[task.workspace]
        new_ws.innerbox.pack_start(b, FALSE,FALSE,0)
        b.expander = new_ws
        self.fixup_names()

    def task_hints_cb(self, task):
        if self.buttons.has_key(task.xwin):
            if task.skip_taskbar:
                self.remove_task_cb(task)
        else:
            if not task.skip_taskbar:
                self.add_task_cb(task)
            
        
    def workspace_count_cb(self, root):
        diff = root.workspace_count - len(self.wspaces)
        while diff > 0:
            a = Expander(self)
            self.wspaces.append(a)
            self.mainbox.pack_start(a.outerbox, FALSE,FALSE,0)
            diff = diff - 1
        while diff < 0:
            old = self.wspaces[len(self.wspaces)-1]
            self.mainbox.remove(old.outerbox)
            self.wspaces.remove(old)
            old.outerbox.destroy()
            diff = diff + 1
        for i in range(len(self.wspaces)):
            self.wspaces[i].label.set_text(str(i+1))
        self.fixup_names()

    def task_focus_cb(self, task):
        try:
            b = self.buttons[task.xwin]
        except KeyError:
            return
        if task.focused:
            b.set_active(TRUE)
        else:
            b.set_active(FALSE)
            
            
    def add_task_cb(self, task):
        if task.name != "Timbar" and not task.skip_taskbar:
            if self.buttons.has_key(task.xwin):
                return
            b = TaskButton(task, self.wspaces[task.workspace])
            self.buttons[task.xwin] = b
            self.wspaces[task.workspace].innerbox.pack_start(b, FALSE,FALSE,0)
            b.show()
            if task.focused:
                b.set_active(TRUE)
            self.fixup_names()

    def remove_task_cb(self, task):
        try:
            b = self.buttons[task.xwin]
        except KeyError:
            return
        
        self.wspaces[task.workspace].innerbox.remove(b)
        b.destroy()
        del self.buttons[task.xwin]
        self.fixup_names()
        
    def fixup_names(self): #this could maybe use further optimising...
        global fixup_names_mutex
        if fixup_names_mutex:
            return
        buttons = self.buttons.values()
        visbuts = filter(lambda(but): but.expander.but.get_active(), buttons)
        sw = screen_width()

        #find total length of the bar, length of all task buttons, and the longest button:
        def tl_bl_and_lb(self=self, visbuts=visbuts):
            ret = [0,0,0]
            ret[0] = ret[0] + self.clock.size_request()[0] #width of clock button
            for ws in self.wspaces:
                ret[0] = ret[0] + ws.but.size_request()[0] #width of expander buttons
            maxlen = 0
            for but in visbuts:
                thislen = but.size_request()[0]
                ret[0] = ret[0] + thislen #width of visible task buttons
                ret[1] = ret[1] + thislen
                if thislen > maxlen:
                    ret[2] = but
                    maxlen = thislen
            return ret

        # force all labels to their maximum length:
        for but in visbuts:
            but.label.set_text(but.dname)

        # force re-packing of widgets:
        for exp in self.wspaces:
            exp.outerbox.hide()
            exp.outerbox.show()
    
        tl,bl,lb = tl_bl_and_lb()
        if sw > tl:
            return

        # take a shortcut towards optimum length (size_request calls are expensive):
        tlets = 0
        for but in visbuts:
            tlets = tlets + len(but.label.get()) #total no. of letters on all buttons
        
        ppl = bl / float(tlets) #approx pixels per letter as float
        maxlets = int(round((sw-(tl-bl))/ppl)) #approx max letters allowed in total
        nbuts = len(visbuts)
        maxlpb = int(round(maxlets/float(nbuts))) #max letters per button if all are larger than this
        smallbuts = []
        bigbuts = [] #and i cannot lie
        lens = []
        freebies = 0 #we get space for extra letters from the smaller buttons
        for but in visbuts:
            thislen = len(but.label.get())
            if thislen < maxlpb:
                smallbuts.append(but)
                freebies = freebies + (maxlpb - thislen)
            else:
                lens.append(thislen)
                bigbuts.append(but)
        maxlpb = maxlpb + int(round(float(freebies)/len(bigbuts))) #corrected max letters per button

        if maxlpb < 4:
            for but in bigbuts:
                but.label.set_text("...")
            return

        for but in bigbuts:
            but.label.set_text(but.label.get()[:(maxlpb-3)] + "...")
            
        # further prune the labels if necessary:
        #(don't worry if we've made them too short; it won't be by much)
        while 1:
            tl,bl,lb = tl_bl_and_lb()
            if tl <= sw:
                break
            st = lb.label.get()
            if len(st) < 4: #we're down to ellipses on all buttons! aarghh!
                break
            lb.label.set_text(st[:-4] + "...")

        
if __name__ == '__main__':
    app = Application()
    mainloop()
