/* stph_icons.h -- Obtain icons as xpm data, resizing if desired.

   Copyright (C) 2000 Rob Hodges <s323140@student.uq.edu.au>

   This file is part of stph.

   stph is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   stph is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with stph; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */


#ifndef __STPH_ICONS_H__
#define __STPH_ICONS_H__ 1

#include <X11/Xlib.h>

/* Obtain an xpm data representation of an icon with a pixmap or
   iconwindow with xid D.  MASK may be set to zero if the app does not
   supply one, else the xid of the bitmap mask.  The image will be
   resized to dimensions (DESIRED_WIDTH x DESIRED_HEIGHT) unless they
   are both set to -1, in which case it will be returned at its
   natural dimensions.  If there is a problem, NULL is returned. */
char **stph_xpm_data_from_drawable(Drawable d, Drawable mask,
                                   int desired_width, int desired_height);

/* Free the data that is malloc'd & returned by the above function. */
void stph_free_xpm_data(char** data);

/* A useful function for the Python bindings; not likely useful
   anywhere else.  Returns the number of strings in DATA. */
long stph_get_xpm_data_length(char** data);


#endif /* ndef __STPH_ICONS_H__ */
